=== data/CMakeLists.txt ===
executable(maketestvol SOURCES maketestvol.cpp)
executable(raw2vol SOURCES raw2vol.cpp LIBS Coin::Coin)
